import Fragment from "./fragment";
import Layer from "./layer";
import Score from "./score";
import createLayer from "./createLayer";

function createFragment(strings: string[], ...values: (Fragment | Layer)[]) {
  let staffNum = 0;
  let fragment = new Fragment();
  let currentVoice = new Fragment();
  const merge = () => {
    fragment = fragment.merge(currentVoice, staffNum);
    currentVoice = new Fragment();
  };
  strings.forEach((string, i) => {
    const staffs = string.split("//");
    staffs.forEach((staff, i) => {
      if (i !== 0) {
        merge();
        staffNum++;
      }
      const voices = staff.split("\\");
      voices.forEach((voice, i) => {
        if (i !== 0) {
          merge();
        }
        let layer = createLayer(voice);
        if (Score.octave) {
          layer = layer.relativeToFixed(Score.octave);
        }
        currentVoice = currentVoice.add(layer);
      });
    });
    const value = values[i];
    if (value) {
      currentVoice = currentVoice.add(value);
    }
  });
  merge();
  return fragment;
}

export default createFragment;
