import Fraction from "fraction.js";
import Duration from "./duration";

abstract class Layers extends Duration {
  constructor(children: any[]) {
    let duration = new Fraction(0);
    let lcd = new Fraction(1);

    for (const value of children) {
      if (value.duration.compare(duration) > 0) {
        duration = value.duration;
      }
      lcd = lcd.lcm(value.lcd);
    }

    super(children, duration, lcd);
  }
}

export default Layers;
