class Octave {
  private static _scale = ["c", "d", "e", "f", "g", "a", "b"];
  private _oct: number;
  private _pname: string;
  private _index: number;

  constructor(oct = 0, pname = "c") {
    this._oct = oct;
    this._pname = pname;
    this._index = Octave._scale.indexOf(pname);
  }

  get clone() {
    return new Octave(this._oct, this._pname);
  }

  next(octChange: number, pname: string) {
    const index = Octave._scale.indexOf(pname);
    const interval = index - this._index;
    octChange += interval > 3 ? -1 : interval < -3 ? 1 : 0;
    this._oct += octChange;
    this._pname = pname;
    this._index = index;

    return this._oct;
  }
}

export default Octave;
