import Fraction from "fraction.js";

const notes: { [index: string]: string } = {
  1: "\uECA2",
  2: "\uECA3",
  4: "\uECA5",
  8: "\uECA7",
  16: "\uECA9",
  32: "\uECAB",
  64: "\uECAD",
  128: "\uECAF",
};

const dot = "\uECB7 ";

export function formatBeatValue(type: number, dots: number) {
  return `${notes[type]} ${dot.repeat(dots)}=`;
}

export function formatTempo(tempo: Fraction) {
  return `${tempo.n}:${tempo.d}`;
}
