import Event from "../event";
import { Entry } from "../types";

function* getEvents<T>(
  entries: Entry[],
  func: (event?: Event) => T
): Generator<T, T, T> {
  for (const entry of entries) {
    if (entry instanceof Event) {
      yield func(entry);
    } else {
      yield* getEvents(entry.children, func);
    }
  }
  return func();
}

export default getEvents;
