import Fraction from "fraction.js";
import Tempo from "../../tempo";

function setTempoProps(children: Tempo[]) {
  let tempoLcm = new Fraction(1);
  let durationLcd = new Fraction(1);
  for (const tempo of children) {
    const { duration, props } = tempo;
    const durationD = new Fraction(duration.d);
    tempoLcm = tempoLcm.lcm(props.tempo).lcm(duration);
    if (durationD.compare(durationLcd) > 0) {
      durationLcd = durationD;
    }
  }
  return { tempoLcm, durationLcd };
}

export default setTempoProps;
