import Duration from "./duration";
import Pitch from "./pitch";
import Direction from "./direction";
import Octave from "./octave";
import { EventProps, DurationInput, PitchInput, MusicXmlProps, MeiProps, EventDataProps } from "./types";
declare class Event extends Duration {
    children: Pitch[];
    props: EventProps;
    constructor(children?: Pitch[], props?: EventProps);
    setDuration(value: DurationInput, hidden?: boolean): Event;
    setPitches(input: PitchInput | PitchInput[]): Event;
    setPitches(...input: PitchInput[]): Event;
    addDirection(value: Direction): Event;
    setTie(tie: boolean): Event;
    relativeToFixed(octave: Octave): Event;
    setTies(previous: number[], current: number[], next: number[]): Event;
    setId(): Event;
    private _copy;
    toMusicXml({ lcd, timeMod, staff, voice, tuplets }: MusicXmlProps): any[];
    toMei(props: MeiProps): any;
    toEventData({ lcd, timeMod }: EventDataProps): {
        id: string;
        duration: number;
        pitches: {
            num: number;
            tie: boolean;
        }[];
    };
}
export default Event;
