import Fraction from "fraction.js";
import Layers from "./layers";
import Staff from "./staff";
import Layer from "./layer";
import TempoFragment from "./tempoFragment";
import AccelFragment from "./accelFragment";
import { DurationInput, PipeProps, MeiProps, EventDataProps } from "./types";
declare class Fragment extends Layers {
    children: Staff[];
    constructor(children?: Staff[]);
    add(value: Layer | Fragment): Fragment;
    merge(value: Fragment, staffNum: number): Fragment;
    tuplet(outer: number, inner: number, beatValue?: DurationInput, hidden?: boolean): Fragment;
    tempo(tempo: any, beatValue?: DurationInput): TempoFragment;
    accel(startTempo: any, endTempo: any, numBeats: number, beatValue?: DurationInput): AccelFragment;
    setTies(): Fragment;
    transpose(interval: number): Fragment;
    invert(axis: number): Fragment;
    pipe(...transforms: Array<(layer: Layer, props: PipeProps) => Layer>): Fragment;
    toMusicXml(id: string | undefined, clefs: string[]): any;
    toMei(props: MeiProps): any[];
    toEventData(props: EventDataProps): any[];
    toBeatData(lcd: Fraction): number[];
    toTimingData(): {
        tempos: TempoObject[];
        endPosition: Fraction;
    };
}
export default Fragment;
