import Fraction from "fraction.js";
import Event from "./event";
import Entries from "./entries";
import Direction from "./direction";
import { Entry, EventInput, DurationInput, TempoProps, AccelProps, MusicXmlProps, MeiProps, EventDataProps } from "./types";
declare class Layer extends Entries {
    children: Entry[];
    constructor(values?: Entry[], props?: {});
    static from(input: EventInput | EventInput[]): Layer;
    static from(...input: EventInput[]): Layer;
    add(value: Event | Layer): Layer;
    addRests(total: Fraction, hidden?: boolean): Layer;
    private static _splitDuration;
    tuplet(outer: number, inner: number, beatValue?: DurationInput, hidden?: boolean): Layer;
    tempo(props: TempoProps): Layer;
    accel(props: AccelProps): Layer;
    addDirection(value: Direction): any;
    relativeToFixed(startOctave: number): any;
    setTies(): any;
    transpose(interval: number): any;
    invert(axis: number): any;
    toMusicXml(props: MusicXmlProps): any;
    toMei(props: MeiProps): any;
    toEventData(props: EventDataProps): any;
    toBeatData(lcd: Fraction): Generator<number, void, unknown>;
    toTimingData(): {
        tempos: TempoObject[];
        endPosition: Fraction;
    };
}
export default Layer;
