import Fragment from "./fragment";
import TempoFragment from "./tempoFragment";
import AccelFragment from "./accelFragment";
import { PartProps, MeiProps, EventDataProps } from "./types";
import Fraction from "fraction.js";
declare class Part {
    fragment: Fragment;
    props: PartProps;
    constructor(value: Fragment | (Fragment | TempoFragment | AccelFragment)[], name?: string, clefs?: string[]);
    get name(): string;
    toMusicXml(id: string): any;
    toMei(props: MeiProps): any[];
    toEventData(props: EventDataProps): any[];
    toBeatData(lcd: Fraction): number[];
    toTimingData(): {
        tempos: TempoObject[];
        endPosition: Fraction;
    };
}
export default Part;
