import Fraction from "fraction.js";
import Layers from "./layers";
import Layer from "./layer";
import { DurationInput, PipeProps, MusicXmlProps, MeiProps, EventDataProps } from "./types";
declare class Staff extends Layers {
    children: Layer[];
    constructor(children?: Layer[]);
    add(value: Layer | Staff): Staff;
    merge(value: Staff): Staff;
    tuplet(outer: number, inner: number, beatValue?: DurationInput, hidden?: boolean): Staff;
    pipe(transform: (layer: Layer, props: PipeProps) => Layer, props: PipeProps): Staff;
    toMusicXml(props: MusicXmlProps): any[];
    toMei(props: MeiProps): any[];
    toEventData(props: EventDataProps): any[];
    toBeatData(lcd: Fraction): number[];
    toTimingData(): {
        tempos: TempoObject[];
        endPosition: Fraction;
    };
}
export default Staff;
