import ScoreContent from ".";

function highlightEvents(content: ScoreContent) {
  const { currentIds, previousIds } = content;
  if (currentIds && currentIds !== previousIds) {
    const { svg } = content;
    if (svg) {
      currentIds.forEach((currentId, i) => {
        const previousId = previousIds ? previousIds[i] : null;
        if (currentId !== previousId) {
          if (currentId) {
            svg.getElementById(currentId).classList.add("current");
          }
          if (previousId) {
            svg.getElementById(previousId).classList.remove("current");
          }
        }
      });
    }
    content.previousIds = currentIds;
  }
}

export default highlightEvents;
