import { LitElement, css, html } from "lit";
import { customElement, property } from "lit/decorators.js";
import { connect } from "pwa-helpers/connect-mixin";
import store, { RootState } from "../../store";
import Scroll from "./scroll";

@customElement("score-footer")
class ScoreFooter extends connect(store)(LitElement) {
  @property()
  scrollPos = 0;

  static get styles() {
    return css`
      mwc-slider {
        flex-grow: 1;
      }
    `;
  }

  stateChanged(state: RootState) {
    this.scrollPos = state.scrollPos;
  }

  render() {
    return html` ${Scroll(this.scrollPos)} `;
  }
}

export default ScoreFooter;
