import { LitElement, css, html } from "lit";
import { customElement, property } from "lit/decorators.js";
import { connect } from "pwa-helpers/connect-mixin";
import store, { RootState } from "../../store";
import MidiOutput from "./midiOutput";
import StartStop from "./startStop";
import Tempo from "./tempo";

@customElement("score-header")
class ScoreHeader extends connect(store)(LitElement) {
  @property()
  state: RootState | null = null;

  static get styles() {
    return css``;
  }

  stateChanged(state: RootState) {
    this.state = state;
  }

  render() {
    if (this.state) {
      return html`
        ${MidiOutput(this.state)} ${StartStop(this.state)} ${Tempo(this.state)}
      `;
    }
  }
}

export default ScoreHeader;
