import { html } from "lit";
import WebMidi from "webmidi";
import store, { RootState } from "../../store";
import { setMidiOutput } from "../../store/reducer";
import "@material/mwc-select";
import "@material/mwc-list/mwc-list-item";

const getMidiEnabled = (state: RootState) => state.midiEnabled;

const MidiOutput = (state: RootState) => {
  const midiEnabled = getMidiEnabled(state);
  const outputs = WebMidi.outputs;
  const selected = (e: any) =>
    store.dispatch(setMidiOutput(outputs[e.detail.index].name));
  return html`
    <div>
      <mwc-select
        label=${midiEnabled ? "midi output" : "midi unavailable"}
        @selected=${selected}
      >
        ${midiEnabled
          ? outputs.map(
              ({ name }, i) => html`
                <mwc-list-item ?selected=${i === 0} value=${name}
                  >${name}</mwc-list-item
                >
              `
            )
          : null}
      </mwc-select>
    </div>
  `;
};

export default MidiOutput;
