import { html } from "lit";
import store, { RootState } from "../../store";
import { start, stop } from "../../store/reducer";
import "@material/mwc-button";

const startTime = () => performance.now() + 100;

const getStartOffset = (state: RootState) => state.startOffset;
const getSyncing = (state: RootState) => state.syncing;
const getPlaying = (state: RootState) => state.playing;

const StartStop = (state: RootState) => {
  const startOffset = getStartOffset(state);
  const syncing = getSyncing(state);
  const playing = getPlaying(state);
  const label = syncing ? "sync" : playing ? "stop" : "start";
  const click = () =>
    syncing || playing
      ? store.dispatch(stop())
      : store.dispatch(start({ startTime: startTime(), startOffset }));
  return html`
    <div>
      <mwc-button outlined label=${label} @click=${click}></mwc-button>
    </div>
  `;
};

export default StartStop;
