import { html } from "lit";
import store, { RootState } from "../../store";
import { setBaseTempo } from "../../store/reducer";
import "@material/mwc-textfield";

const getBaseTempo = (state: RootState) => state.baseTempo;

const Tempo = (state: RootState) => {
  const baseTempo = getBaseTempo(state);
  const change = (e: any) => store.dispatch(setBaseTempo(e.target.value));
  return html`
    <mwc-textfield
      label="tempo"
      type="number"
      min="1"
      value=${baseTempo}
      @change=${change}
    ></mwc-textfield>
  `;
};

export default Tempo;
