import { configureStore, getDefaultMiddleware } from "@reduxjs/toolkit";
import root from "./reducer";
import startTimer from "./thunks/startTimer";

const store = configureStore({
  reducer: root,
  middleware: getDefaultMiddleware({
    immutableCheck: false,
    serializableCheck: false,
  }),
});

store.dispatch(startTimer());

export type RootState = ReturnType<typeof root>;

export default store;
