export interface Pitch {
  num: number;
  tie: boolean;
}

export interface Event {
  id: string;
  duration: number;
  pitches: Pitch[];
}

export interface ScoreEvent {
  id: string;
  start: number;
  duration: number;
  end: number;
  pitches: Pitch[];
}

export interface MidiEvent {
  start: number;
  pitches: {
    duration: number;
    pitchNum: number;
  }[];
}

export interface Data {
  divisions: number;
  events: Event[][][];
}

export interface RootState {
  midiEnabled: boolean;
  midiOutput: string;
  baseTempo: number;
  midiBufferSize: number;
  data: Data | null;
  scoreEvents: ScoreEvent[][][];
  scoreEventIndexes: number[][];
  midiEvents: MidiEvent[][][];
  midiEventIndexes: number[][];
  currentMidiEvents: MidiEvent[][][];
  totalTime: number;
  startTime: number;
  startOffset: number;
  syncing: boolean;
  playing: boolean;
  scrollPos: number;
}
