import setStop from "./setStop";
import { RootState } from "../types";

function setCurrentScoreEvents(state: RootState, currentTime: number) {
  if (state.syncing) {
    if (currentTime >= state.startTime) {
      state.syncing = false;
      state.playing = true;
    }
  } else if (state.playing) {
    currentTime = currentTime - state.startTime + state.startOffset;
    if (currentTime > state.totalTime) {
      setStop(state);
    } else {
      // REMOVED DUE TO LAYOUT THRASHING
      // state.scrollPos = currentTime / state.totalTime
      let update = false;
      const scoreEventIndexes = state.scoreEventIndexes.map((part, partIndex) =>
        part.map((currentIndex, sequenceIndex) => {
          const { end } =
            state.scoreEvents[partIndex][sequenceIndex][currentIndex];
          if (currentTime >= end) {
            const nextIndex = currentIndex + 1;
            if (state.scoreEvents[partIndex][sequenceIndex][nextIndex]) {
              update = true;
              return currentIndex + 1;
            } else {
              return currentIndex;
            }
          } else {
            return currentIndex;
          }
        })
      );
      if (update) {
        state.scoreEventIndexes = scoreEventIndexes;
      }
    }
  }
}

export default setCurrentScoreEvents;
