import { RootState, ScoreEvent, MidiEvent } from "../types";

function getEventIndexes(
  events: (ScoreEvent | MidiEvent)[][][],
  startOffset: number
) {
  return events.map((part) =>
    part.map((sequence) => {
      const index = sequence.findIndex(({ start }) => start > startOffset);
      return index === -1 ? sequence.length - 1 : index - 1;
    })
  );
}

function setEventIndexes(state: RootState) {
  state.scoreEventIndexes = getEventIndexes(
    state.scoreEvents,
    state.startOffset
  );
  state.midiEventIndexes = getEventIndexes(state.midiEvents, state.startOffset);
}

export default setEventIndexes;
